﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TCCInvoice
{
    internal class Program
    {
        static void Main(string[] args)
        {
            // 建立InvoiceGenerator類別的物件
            InvoiceGenerator myInvoice = new InvoiceGenerator();

            // 註冊發票號碼已開立的事件通知
            myInvoice.InvoiceGenerated += MyInvoice_InvoiceGenerated;
            // 註冊發票號碼開立失敗的事件通知
            myInvoice.InvoiceGenerationFailed += MyInvoice_InvoiceGenerationFailed;

            // 填具待開立發票的相關資料(Preinvoice)
            myInvoice.DataNumber = "202202080058";
            myInvoice.DataDate = DateTime.Today;
            myInvoice.BuyerId = null; // 一般消費者
            myInvoice.TotalAmount = 524;
            myInvoice.CarrierId1 = "/CPDF.O2";
            myInvoice.ContactEmail = "snoopy.h.huang@outlook.com";
            myInvoice.ContactPhone = "0929168960";
            myInvoice.AddInvoiceItem(0, "充電服務費", 41.5793, "度", 12, 499, "充電服務費每度12元");
            myInvoice.AddInvoiceItem(1, "占用費", 0.5, "小時", 50, 25, "占用費每小時50元");
            //開立發票
            myInvoice.GetInvoiceResponse();

            //下一張
            //myInvoice.DataNumber = "202202031234567890";
            //myInvoice.DataDate = DateTime.Today;
            //myInvoice.BuyerId = "30435973"; //營業人
            //myInvoice.TotalAmount = 1204;
            //myInvoice.CarrierId1 = null;
            //myInvoice.ContactEmail = "snoopy_huang@phihong.com.tw";
            //myInvoice.ContactPhone = "0972637981";
            //myInvoice.AddInvoiceItem(0, "充電服務費", 120.4130, "度", 10, 1204, "每度10元");
            //myInvoice.GetInvoiceResponse();

            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }

        private static void MyInvoice_InvoiceGenerated(string dataNumber, string invoiceNumber,
                                                       string invoiceDate, string invoiceTime, string carrierNumber)
        {
            Console.WriteLine("發票已開立-----");
            Console.WriteLine("單據編號：" + dataNumber);
            Console.WriteLine("發票號碼：" + invoiceNumber);
            Console.WriteLine("發票日期：" + invoiceDate);
            Console.WriteLine("發票時間：" + invoiceTime);
            Console.WriteLine("載具號碼：" + carrierNumber);
        }

        private static void MyInvoice_InvoiceGenerationFailed(string dataNumber, string description)
        {
            Console.WriteLine("發票開立失敗-----");
            Console.WriteLine("單據編號：" + dataNumber);
            Console.WriteLine("錯誤代碼與描述：" + description);
        }
    }
}
